\section{Container and VMs}

\subsection{Virtualization}
Creation of a virtual machine that acts like a real computer with an operating system. The host machine is where the virtualisation software runs and on top of this runs a guest OS. There are two types of hypervisors: bare-metal - Xen, hosted - Virtualbox. 

\subsection{Introduction}
Docker is a containerisation platform.

\begin{minipage}{0.5\textwidth}
	\textbf{Container}
	\begin{itemize}
		\item Reduced size of snapshots 2MB vs 45 MB (alpine)
		\item Quicker spinning up apps
		\item Amiable memory is shared
		\item Process-based isolation (share same kernel)	
	\end{itemize}
\end{minipage}
\begin{minipage}{0.5\textwidth}
	\textbf{Virtual Machine}
	\begin{itemize}
		\item Apps cann access all OS resources
		\item Live migrations
		\item Pre allocate memory
		\item Full isolation	
	\end{itemize}
\end{minipage}

\subsection{Container}
\textbf{OverlayFS:} The lower directory can be read-only or could be an overlay itself. The upper directory is normally writable.

\textbf{Cgroups:} Are control groups for limits, isolates, priorization of CPU, memory, disk I/O, network.

\textbf{Linux Network Namespaces:} provide isolation of the system resources associated with the networking.